﻿Param(
  [string]$filePath
)
if ([string]::IsNullOrEmpty($filePath) -or -not (Test-Path $filePath))
    {
        "File `"$filePath`" does not exists!";
        return;
    }
#Remember current location
$location = Get-Location;
#Get absolute location of file
$filePath = Resolve-Path $filePath;
#Set current folder to file folder
Split-Path $filePath | Set-Location;
Copy-Item $filePath ($filePath+".bak");
#Load xml file
[xml]$file = Get-Content $filePath ;
#Select all videoClips of type "file"
$videoClips = $file.SelectNodes("/composition/decks/deck/clip/videoClip/source[@type=`"file`"]");
foreach ($clip in $videoClips)
{
    #Replace absolute path with relative
    [string]$rel = Resolve-Path -Relative $clip.name;
    $clip.name = $rel;
}
#Select all audioClips of type "file"
$audioClips = $file.SelectNodes("/composition/decks/deck/clip/audioClip/source[@type=`"file`"]");
foreach ($clip in $audioClips)
{
    #Replace absolute path with relative
    [string]$rel = Resolve-Path -Relative $clip.name;
    $clip.name = $rel;
}
#Save xml file
$file.Save($filePath);

#Correct updating of unicode symbols
$fileContent = Get-Content $filePath;
$newFile = "";
#SLOOOOOW
for ($i = 0; $i -lt $fileContent.Length; $i++)
{
    $line = $fileContent[$i];
    for ($j = 0; $j -lt $line.Length; $j++)
    {
        $c = $line[$j];
        if ($c -gt 0 -and $c -lt 255)
        {
            $newFile += $c;
        }
        else
        {
        
            $newFile += "&#" + [System.Convert]::ToInt32([System.Convert]::ToChar($c)) + ";";
        }
    }
}

#Save file with correct unicode symbols
Set-Content -Value $newFile $filePath;
#Return to start location
Set-Location $location;